diff --git a/core/src/aos_main.cpp b/core/src/aos_main.cpp
index 37a8c1c..d404768 100644
--- a/core/src/aos_main.cpp
+++ b/core/src/aos_main.cpp
@@ -1343,35 +773,155 @@ int main(void)
 #if defined(MODULE_SHUTDOWN_PERIPHERY_IF)
   MODULE_SHUTDOWN_PERIPHERY_IF();
 #endif /* defined(MODULE_SHUTDOWN_PERIPHERY_IF) */
-#if (HAL_USE_CAN == TRUE)
-  if (MODULE_HAL_CAN.state != CAN_STOP) {
-    canStop(&MODULE_HAL_CAN);
-  }
-#endif /* (HAL_USE_CAN == TRUE) */
 
 #if defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_4)
 #if defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_4_ARGS)
-    AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_4(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_4_ARGS);
+  AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_4(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_4_ARGS);
 #else /* defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_4_ARGS) */
-    AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_4();
+  AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_4();
 #endif /* defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_4_ARGS) */
 #endif /* defined(AMIROOS_CFG_MAIN_SHUTDOWN_HOOK_4) */
 
-  // finally hand over to bootloader
-  aosSysShutdownFinal(shutdown);
+#if (AMIROOS_CFG_SSSP_ENABLE == true)
+
+  // proceed to SSSP shutdown stage 1.3
+  aosSsspProceed(NULL, 0, 0, NULL);
+  aosDbgAssert(aos.sssp.stage == AOS_SSSP_STAGE_SHUTDOWN_1_3);
+
+#if (AMIROOS_CFG_SSSP_SHUTDOWN == true)
+
+  /* AMiRo-OS performs SSSP shutdown phase
+   * NOTE:
+   * The initiating module could deactivate PD at this point to indicate a restart rather than a shutdown request.
+   * AMiRo-OS does not support restart though, thus the signal is not changed.
+   */
+
+  // proceed to SSSP shutdown stage 2.1
+  while (aosSsspProceed(&_eventListenerGPIO, MODULE_SSSP_EVENTFLAG_S, EVENTMASK_GPIO, &eventmask) != AOS_SUCCESS) {
+    /*
+     * This code is executed if the received event was not about a deactivation of the synchronization signal.
+     * The received event could be caused by any listener.
+     */
+    // GPIO event
+    if (eventmask & _eventListenerGPIO.events) {
+      eventflags = chEvtGetAndClearFlags(&_eventListenerGPIO);
+#if defined(MODULE_SSSP_SHUTDOWN_1_3_GPIOEVENT_HOOK)
+        MODULE_SSSP_SHUTDOWN_1_3_GPIOEVENT_HOOK(eventmask, eventflags);
+#else /* defined(MODULE_SSSP_SHUTDOWN_1_3_GPIOEVENT_HOOK) */
+        /* silently ignore any other GPIO events */
+#endif /* defined(MODULE_SSSP_SHUTDOWN_1_3_GPIOEVENT_HOOK) */
+    }
+    // OS event
+    else if (eventmask & _eventListenerOS.events) {
+      eventflags = chEvtGetAndClearFlags(&_eventListenerOS);
+      _unexpectedEventError(eventmask, eventflags);
+    }
+    // unknown event
+    else {
+      _unexpectedEventError(eventmask, 0);
+    }
+  }
+  aosDbgAssert(aos.sssp.stage == AOS_SSSP_STAGE_SHUTDOWN_2_1);
+
+  // proceed to SSSP shutdown stage 2.2
+  aosSsspProceed(NULL, 0, 0, &eventmask);
+  aosDbgAssert(aos.sssp.stage == AOS_SSSP_STAGE_SHUTDOWN_2_2);
+  if (shutdown == AOS_SHUTDOWN_PASSIVE) {
+    aosDbgPrintf("%s request received\n", eventmask ? "shutdown" : "restart");
+  }
+  /* NOTE:
+   * Actually the call of aosSsspProceed() returned an indicator, whether a shutdown or restart has been initiated.
+   * Since AMiRo-OS does not support restart, this return value is ignored and shutdown is assumed.
+   */
+
+  // the initiating module broadcasts the shutdown identifier
+  if (shutdown != AOS_SHUTDOWN_PASSIVE) {
+    // since AMiRo-OS does not support multiple ways to shutdown or restart, the special identifier 0 is broadcasted.
+    aosSsspShutdownBroadcastIdentifier(0);
+  }
+  // passive modules receive the broadcasted identifier
+  else {
+    unsigned int identifier = 0;
+
+    // receive the identifier, which specifies the type of shutdown/restart
+    while ((eventmask = aosSsspShutdownWaitForIdentifierPulse(&_eventListenerGPIO, MODULE_SSSP_EVENTFLAG_S, EVENTMASK_SSSPTIMER, &identifier)) != EVENTMASK_SSSPTIMER) {
+      // GPIO event
+      if (eventmask & _eventListenerGPIO.events) {
+        eventflags = chEvtGetAndClearFlags(&_eventListenerGPIO);
+#if defined(MODULE_SSSP_SHUTDOWN_2_2_GPIOEVENT_HOOK)
+        MODULE_SSSP_SHUTDOWN_2_2_GPIOEVENT_HOOK(eventmask, eventflags);
+#else /* defined(MODULE_SSSP_SHUTDOWN_2_2_GPIOEVENT_HOOK) */
+        /* silently ignore any other GPIO events */
+#endif /* defined(MODULE_SSSP_SHUTDOWN_2_2_GPIOEVENT_HOOK) */
+        /* silently ignore any GPIO events */
+      }
+      // OS event
+      else if (eventmask & _eventListenerOS.events) {
+        eventflags = chEvtGetAndClearFlags(&_eventListenerOS);
+        _unexpectedEventError(eventmask, eventflags);
+      }
+      // unknown event
+      else {
+        _unexpectedEventError(eventmask, 0);
+      }
+    }
+
+    // Since AMiRo-OS does not support multiple ways to shutdown or restart, the identifier is ignored.
+  }
+
+  // proceed to SSSP shutdown stage 2.3
+  aosSsspProceed(NULL, 0, 0, NULL);
+  aosDbgAssert(aos.sssp.stage == AOS_SSSP_STAGE_SHUTDOWN_2_3);
 
   /*
-   * ##########################################################################
-   * # after shutdown/restart                                                 #
-   * ##########################################################################
-   *
-   * NOTE: This code will not be executed, since the bootloader callbacks will stop/restart the MCU.
-   *       It is included nevertheless for the sake of completeness and to explicitely indicate,
-   *       which subsystems should NOT be shut down.
+   * Since AMiRo-OS does only support one basic shutdown and no restart at all, the final shutdown is kept very simple.
    */
 
-  // return an error, since this code should not be executed
-  return -1;
+  // disable interrupts
+  irqDeinit();
+  chSysDisable();
+
+  chThdExit(MSG_OK);
+  return MSG_OK;
+
+#else /* (AMIROOS_CFG_SSSP_SHUTDOWN == true) */
+
+  /* hand over to the bootloader to perform SSSP shutdown phase */
+  aosSysShutdownToBootloader(shutdown);
+
+  aosDbgAssertMsg(false, "AMiRo-OS must not proceed to this point!");
+  chThdExit(MSG_RESET);
+  return MSG_RESET;
+
+#endif /* (AMIROOS_CFG_SSSP_SHUTDOWN == true) */
+
+#else /* (AMIROOS_CFG_SSSP_ENABLE == true) */
+
+  /*
+   * Depending on the configured bootloader, trivial shutdown is either executed by AMiRo-OS or by that bootloader.
+   */
+#if (AMIROOS_CFG_BOOTLOADER == AOS_BOOTLOADER_NONE)
+
+  /* AMiRo-OS performs trivial shutdown */
+
+  // disable interrupts
+  irqDeinit();
+  chSysDisable();
+
+  chThdExit(MSG_OK);
+  return MSG_OK;
+
+#elif (AMIROOS_CFG_BOOTLOADER == AOS_BOOTLOADER_AMiRoBLT)
+
+  /* AMiRo-BLT performns shutdown */
+  aosSysShutdownToBootloader(shutdown);
+
+  aosDbgAssertMsg(false, "AMiRo-OS must not proceed to this point!");
+  chThdExit(MSG_RESET);
+  return MSG_RESET;
+
+#endif /* (AMIROOS_CFG_BOOTLOADER == X) */
+#endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
 }
 
 /******************************************************************************/
diff --git a/core/src/aos_shell.c b/core/src/aos_shell.c
index f1c5fd3..3e4ceea 100644
--- a/core/src/aos_shell.c
+++ b/core/src/aos_shell.c
@@ -28,7 +28,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #include <amiroos.h>
 #include <string.h>
 
-#if (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true)
+#if (AMIROOS_CFG_SHELL_ENABLE == true) || defined(__DOXYGEN__)
 
 /******************************************************************************/
 /* LOCAL DEFINITIONS                                                          */
@@ -1637,7 +1637,7 @@ void aosShellThread(void* shell)
       {
         eventflags = chEvtGetAndClearFlags(&((aos_shell_t*)shell)->os.eventListener);
         // handle shutdown/restart events
-        if (eventflags & AOS_SYSTEM_EVENTFLAGS_SHUTDOWN) {
+        if (eventflags & AOS_SYSTEM_EVENTFLAGS_SHUTDOWN_MASK) {
           chThdTerminate(((aos_shell_t*)shell)->thread);
         } else {
           // print an error message
@@ -1720,6 +1720,6 @@ void aosShellThread(void* shell)
   // no chSysUnlock() required since the thread has been terminated an all waiting threads have been woken up
 }
 
-#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true)*/
+#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) */
 
 /** @} */
diff --git a/core/src/aos_sssp.c b/core/src/aos_sssp.c
new file mode 100644
index 0000000..683dd79
--- /dev/null
+++ b/core/src/aos_sssp.c
@@ -0,0 +1,573 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+/**
+ * @file    aos_sssp.c
+ * @brief   SSSP related code.
+ *
+ * @addtogroup aos_sssp
+ * @{
+ */
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_SSSP_ENABLE == true) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+#if (AMIROOS_CFG_SSSP_MASTER == true) || defined (__DOXYGEN__)
+
+/**
+ * @brief   A timer event based delays.
+ */
+static virtual_timer_t _delayTimer;
+
+/**
+ * @brief   Event source for the delay timer.
+ */
+static event_source_t _eventSourceDelay;
+
+/**
+ * @brief   Event listener for the delay event.
+ */
+static event_listener_t _eventListenerDelay;
+
+#endif /* (AMIROOS_CFG_SSSP_MASTER == true) */
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+#if (AMIROOS_CFG_SSSP_MASTER == true) || defined (__DOXYGEN__)
+
+/**
+ * @brief   General callback function to be used for any local timers.
+ *
+ * @param[in] par   A pointer to an @p event_source_t to be fired.
+ */
+static void _timerCallback(void* par)
+{
+  aosDbgCheck(par != NULL);
+
+  chSysLockFromISR();
+  chEvtBroadcastI((event_source_t*)par);
+  chSysUnlockFromISR();
+
+  return;
+}
+
+#endif /* (AMIROOS_CFG_SSSP_MASTER == true) */
+
+/**
+ * @brief   Waits for the S signal to switch to the desired state.
+ *
+ * @param[in]   listener      Pointer to the GPIO event listener to be used.
+ * @param[in]   flags         Event flags to listen to by the event listener (indicating a S signal event).
+ * @param[in]   signalstate   Desired state of the S signal ti be waited for.
+ * @param[out]  received      Output variable to store the received event mask to.
+ *
+ * @return  Status, indicating whether the expected event was received.
+ */
+static inline aos_status_t _waitForS(event_listener_t* listener, eventflags_t flags, apalControlGpioState_t signalstate, eventmask_t* received)
+{
+  aosDbgCheck(listener != NULL);
+  aosDbgCheck(flags != 0);
+  aosDbgCheck(received != NULL);
+
+  // wait for the next event (do not apply any filters in order not to miss any events)
+  *received = chEvtWaitOne(ALL_EVENTS);
+  // if the correct event was triggered
+  if (*received == listener->events) {
+    apalControlGpioState_t s;
+    apalControlGpioGet(&moduleSsspGpioS, &s);
+    // only check for the expected event
+    if (flags & listener->flags && s == signalstate) {
+      // unset the expected flags but keep any other ones
+      listener->flags &= ~flags;
+      return AOS_SUCCESS;
+    }
+  }
+
+  return AOS_FAILURE;
+}
+
+#if (AMIROOS_CFG_SSSP_MASTER == true) || defined(__DOXYGEN__)
+
+/**
+ * @brief   Uses the local delay timer to setup a timed event and waits for it to fire.
+ *
+ * @param[in]   dt          Delay time in microseconds to be set to the timer.
+ * @param[in]   mask        Event mask to be used for the delay timer.
+ * @param[in]   arm_timer   Flag to indicate whether the timer has to be armed yet (i.e. on first call of this function).
+ * @param[out]  received    Output variable to store the received event mask to.
+ *
+ * @return  Status, indicating whether the expected event (delay timer) was received.
+ */
+static inline aos_status_t _delay(uint32_t dt, eventmask_t mask, bool arm_timer, eventmask_t* received)
+{
+  aosDbgCheck(dt != TIME_IMMEDIATE);
+  aosDbgCheck(mask != 0);
+  aosDbgCheck(received != NULL);
+
+  // arm the delay timer once
+  if (arm_timer) {
+    chEvtRegisterMask(&_eventSourceDelay, &_eventListenerDelay, mask);
+    chVTSet(&_delayTimer, chTimeUS2I(dt), _timerCallback, &_eventSourceDelay);
+  }
+
+  // wait for any event to occur (do not apply any filters in order not to miss any events)
+  *received = chEvtWaitOne(ALL_EVENTS);
+
+  // if the timer event was received, cleanup
+  if (*received & _eventListenerDelay.events) {
+    chEvtUnregister(&_eventSourceDelay, &_eventListenerDelay);
+    return AOS_SUCCESS;
+  }
+
+  return AOS_FAILURE;
+}
+
+#endif /* (AMIROOS_CFG_SSSP_MASTER == true) */
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+/**
+ * @brief   Initialize all SSSP related data.
+ */
+void aosSsspInit(void)
+{
+#if (AMIROOS_CFG_SSSP_MSI == true)
+  // module ID is initialized as 'invalid'
+  aos.sssp.moduleId = AOS_SSSP_MODULEID_INVALID;
+#endif /* (AMIROOS_CFG_SSSP_MSI == true) */
+
+#if (AMIROOS_CFG_SSSP_STARTUP == true)
+  // AMiRo-OS has to perform the basic initialization
+  aos.sssp.stage = AOS_SSSP_STAGE_STARTUP_1_1;
+#if (AMIROOS_CFG_DBG == true)
+  // check whether the initial signal configuration is correct
+  {
+    apalControlGpioState_t state;
+    // S signal
+    apalControlGpioGet(&moduleSsspGpioS, &state);
+    aosDbgAssert(state == APAL_GPIO_ON);
+    // PD signal
+    apalControlGpioGet(&moduleSsspGpioPD, &state);
+    aosDbgAssert(state == APAL_GPIO_OFF);
+  }
+#endif /* (AMIROOS_CFG_DBG == true) */
+#else /* (AMIROOS_CFG_SSSP_STARTUP == true) */
+  // basic initialization was already performed by a bootloader
+  aos.sssp.stage = AOS_SSSP_STAGE_STARTUP_2_1;
+#if (AMIROOS_CFG_DBG == true)
+  // check whether the initial signal configuration is correct
+  {
+    apalControlGpioState_t state;
+    // S signal
+    apalControlGpioGet(&moduleSsspGpioS, &state);
+    aosDbgAssert(state == APAL_GPIO_ON);
+    // PD signal
+    apalControlGpioGet(&moduleSsspGpioPD, &state);
+    aosDbgAssert(state == APAL_GPIO_OFF);
+  }
+#endif /* (AMIROOS_CFG_DBG == true) */
+#endif /* (AMIROOS_CFG_SSSP_STARTUP == true) */
+
+#if (AMIROOS_CFG_SSSP_MASTER == true)
+  // initialize static variables
+  chVTObjectInit(&_delayTimer);
+  chEvtObjectInit(&_eventSourceDelay);
+#endif /* (AMIROOS_CFG_SSSP_MASTER == true) */
+
+  return;
+}
+
+/**
+ * @brief   Proceed to the next SSSP stage.
+ *
+ * @param[in]   listener  An optional listener, in case the system has to wait for a specific event.
+ * @param[in]   flags     The relevant flags to wait for (mandatory if a listener is given).
+ * @param[in]   mask      If the stage transition involves a timer event (handled internally by this function),
+ *                        the given input value of this parameter defines the mask to be used for that event.
+ *                        In case a listener was specified, the according mask is retrieved from the listener but this parameter is still used as input for sanity checks.
+ * @param[out]  received  Output variable to store the received event mask to.
+ *
+ * @return  Status, indicating whether proceeding in the protocol was successful.
+ */
+aos_status_t aosSsspProceed(event_listener_t* listener, eventflags_t flags, eventmask_t mask, eventmask_t* received)
+{
+  // local variables
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wunused-but-set-variable"
+  static aos_ssspstage_t laststage = AOS_SSSP_STAGE_UNDEFINED;
+#pragma GCC diagnostic pop
+  aos_ssspstage_t nextstage = aos.sssp.stage;
+
+  // behaviour depends on current SSSP stage of the system
+  switch (aos.sssp.stage) {
+#if (AMIROOS_CFG_SSSP_STARTUP == true)
+
+    /*
+     * Deactivate S signal.
+     * Master node delays execution by one period AOS_SSSP_DELAY.
+     */
+    case AOS_SSSP_STAGE_STARTUP_1_1:
+    {
+#if (AMIROOS_CFG_SSSP_MASTER == true)
+      aosDbgCheck(listener == NULL);
+      aosDbgCheck(flags == 0);
+      aosDbgCheck(mask != 0);
+      aosDbgCheck(received != NULL);
+
+      // delay execution and deactivate the S signal on success
+      if (_delay(AOS_SSSP_DELAY, mask, (laststage != AOS_SSSP_STAGE_STARTUP_1_1), received) == AOS_SUCCESS) {
+        apalControlGpioSet(&moduleSsspGpioS, APAL_GPIO_OFF);
+        nextstage = AOS_SSSP_STAGE_STARTUP_1_2;
+      }
+#else /* (AMIROOS_CFG_SSSP_MASTER == true) */
+      aosDbgCheck(listener == NULL);
+      aosDbgCheck(flags == 0);
+      aosDbgCheck(mask == 0);
+      aosDbgCheck(received == NULL);
+
+      // deactivate S signal and proceed
+      apalControlGpioSet(&moduleSsspGpioS, APAL_GPIO_OFF);
+      nextstage = AOS_SSSP_STAGE_STARTUP_1_2;
+#endif /* (AMIROOS_CFG_SSSP_MASTER == true) */
+      break;
+    }
+
+    /*
+     * Wait for the S signal to become inactive.
+     */
+    case AOS_SSSP_STAGE_STARTUP_1_2:
+    {
+      aosDbgCheck(listener != NULL);
+      aosDbgCheck(flags != 0);
+      aosDbgCheck(mask == listener->events);
+      aosDbgCheck(received != NULL);
+
+      // wait for the S signal to become inactive and proceed on success
+      if (_waitForS(listener, flags, APAL_GPIO_OFF, received) == AOS_SUCCESS) {
+        nextstage = AOS_SSSP_STAGE_STARTUP_1_3;
+      }
+      break;
+    }
+
+    /*
+     * Wait for the S signal to be activated by the master module.
+     * The master delays execution by one period AOS_SSSP_DELAY.
+     */
+    case AOS_SSSP_STAGE_STARTUP_1_3:
+    {
+#if (AMIROOS_CFG_SSSP_MASTER == true)
+      aosDbgCheck(listener == NULL);
+      aosDbgCheck(flags == 0);
+      aosDbgCheck(mask != 0);
+      aosDbgCheck(received != NULL);
+
+      // delay execution and deactivate the S signal on success
+      if (_delay(AOS_SSSP_DELAY, mask, (laststage != AOS_SSSP_STAGE_STARTUP_1_3), received) == AOS_SUCCESS) {
+        apalControlGpioSet(&moduleSsspGpioS, APAL_GPIO_ON);
+        nextstage = AOS_SSSP_STAGE_STARTUP_2_1;
+      }
+#else /* (AMIROOS_CFG_SSSP_MASTER == true) */
+      aosDbgCheck(listener != NULL);
+      aosDbgCheck(flags != 0);
+      aosDbgCheck(mask == listener->events);
+      aosDbgCheck(received != NULL);
+
+      // wait for the S signal to become active and activate it as well and proceed on success
+      if (_waitForS(listener, flags, APAL_GPIO_ON, received) == AOS_SUCCESS) {
+        apalControlGpioSet(&moduleSsspGpioS, APAL_GPIO_ON);
+        nextstage = AOS_SSSP_STAGE_STARTUP_2_1;
+      }
+#endif /* (AMIROOS_CFG_SSSP_MASTER == true) */
+      break;
+    }
+
+#endif /* (AMIROOS_CFG_SSSP_STARTUP == true) */
+
+    /*
+     * Deactivate S signal.
+     * Master node delays execution by one period AOS_SSSP_DELAY
+     */
+    case AOS_SSSP_STAGE_STARTUP_2_1:
+    {
+#if (AMIROOS_CFG_SSSP_MASTER == true)
+      aosDbgCheck(listener == NULL);
+      aosDbgCheck(flags == 0);
+      aosDbgCheck(mask != 0);
+      aosDbgCheck(received != NULL);
+
+      // delay execution and deactivate the S signal on success
+      if (_delay(AOS_SSSP_DELAY, mask, (laststage != AOS_SSSP_STAGE_STARTUP_2_1), received) == AOS_SUCCESS) {
+        apalControlGpioSet(&moduleSsspGpioS, APAL_GPIO_OFF);
+        nextstage = AOS_SSSP_STAGE_STARTUP_2_2;
+      }
+#else /* (AMIROOS_CFG_SSSP_MASTER == true) */
+      aosDbgCheck(listener == NULL);
+      aosDbgCheck(flags == 0);
+      aosDbgCheck(mask == 0);
+      aosDbgCheck(received == NULL);
+
+      // deactivate S signal and proceed
+      apalControlGpioSet(&moduleSsspGpioS, APAL_GPIO_OFF);
+      nextstage = AOS_SSSP_STAGE_STARTUP_2_2;
+      mask = 0;
+#endif /* (AMIROOS_CFG_SSSP_MASTER == true) */
+      break;
+    }
+
+    /*
+     * Wait for the S signal to become inactive.
+     */
+    case AOS_SSSP_STAGE_STARTUP_2_2:
+    {
+      aosDbgCheck(listener != NULL);
+      aosDbgCheck(flags != 0);
+      aosDbgCheck(mask == listener->events);
+      aosDbgCheck(received != NULL);
+
+      // wait for the S signal to become inactive and proceed on success
+      if (_waitForS(listener, flags, APAL_GPIO_OFF, received) == AOS_SUCCESS) {
+#if (AMIROOS_CFG_SSSP_MSI == true)
+        nextstage = AOS_SSSP_STAGE_STARTUP_3;
+#else /* (AMIROOS_CFG_SSSP_MSI == true) */
+        nextstage = AOS_SSSP_STAGE_OPERATION;
+#endif /* (AMIROOS_CFG_SSSP_MSI == true) */
+      }
+      break;
+    }
+
+#if (AMIROOS_CFG_SSSP_MSI == true)
+
+      //TODO
+
+#endif /* (AMIROOS_CFG_SSSP_MSI == true) */
+
+    /*
+     * Delay execution by one perion AOS_SSSP_DELAY, deactivate the SYNC signal and proceed.
+     * NOTE: Actually only the module that initiated the shutdown has to delay execution here.
+     *       For the sake of simlicity though, each module delays execution.
+     */
+    case AOS_SSSP_STAGE_SHUTDOWN_1_2:
+    {
+      aosDbgCheck(listener == NULL);
+      aosDbgCheck(flags == 0);
+      aosDbgCheck(mask == 0);
+      aosDbgCheck(received == NULL);
+
+      // delay execution
+      aosThdUSleep(AOS_SSSP_DELAY);
+      // deactivate S signal
+      apalControlGpioSet(&moduleSsspGpioS, APAL_GPIO_OFF);
+      nextstage = AOS_SSSP_STAGE_SHUTDOWN_1_3;
+      break;
+    }
+
+#if (AMIROOS_CFG_SSSP_SHUTDOWN == true)
+
+    /*
+     * Wait for S signal to become inactive.
+     */
+    case AOS_SSSP_STAGE_SHUTDOWN_1_3:
+    {
+      aosDbgCheck(listener != NULL);
+      aosDbgCheck(flags != 0);
+      aosDbgCheck(mask == listener->events);
+      aosDbgCheck(received != NULL);
+
+      // wait for the S signal to become inactive and proceed on success
+      if (_waitForS(listener, flags, APAL_GPIO_OFF, received) == AOS_SUCCESS) {
+        nextstage = AOS_SSSP_STAGE_SHUTDOWN_2_1;
+      }
+      break;
+    }
+
+    /*
+     * Evaluate PD signal to determine whether a shutdown or restart is requested.
+     * The logical state is returned by the function call.
+     */
+    case AOS_SSSP_STAGE_SHUTDOWN_2_1:
+    {
+      aosDbgCheck(listener == NULL);
+      aosDbgCheck(flags == 0);
+      aosDbgCheck(mask == 0);
+      aosDbgCheck(received != NULL);
+
+      // evaluate PD signal
+      apalControlGpioState_t pd;
+      apalControlGpioGet(&moduleSsspGpioPD, &pd);
+      *received = (pd == APAL_GPIO_ON) ? (eventmask_t)~0 : 0;
+      nextstage = AOS_SSSP_STAGE_SHUTDOWN_2_2;
+      break;
+    }
+
+    /*
+     * Proceed with no further actions required.
+     */
+    case AOS_SSSP_STAGE_SHUTDOWN_2_2:
+    {
+      aosDbgCheck(listener == NULL);
+      aosDbgCheck(flags == 0);
+      aosDbgCheck(mask == 0);
+      aosDbgCheck(received == NULL);
+
+      nextstage = AOS_SSSP_STAGE_SHUTDOWN_2_3;
+      break;
+    }
+
+#endif /* (AMIROOS_CFG_SSSP_SHUTDOWN == true) */
+
+    default:
+    {
+      // this case must never occur!
+      aosDbgAssertMsg(false, "Invalid SSSP stage tranition occurred");
+      break;
+    }
+  } /* end of switch (aos.sssp.stage) */
+
+  // outro and return
+  laststage = aos.sssp.stage;
+  const aos_status_t status = (nextstage > aos.sssp.stage) ? AOS_SUCCESS : AOS_FAILURE;
+  aos.sssp.stage = nextstage;
+
+  return status;
+}
+
+void aosSsspShutdownInit(void)
+{
+  // activate S signal
+  apalControlGpioSet(&moduleSsspGpioS, APAL_GPIO_ON);
+  // proceed to shutdown phase
+  aos.sssp.stage = AOS_SSSP_STAGE_SHUTDOWN_1_2;
+
+  return;
+}
+
+#if (AMIROOS_CFG_SSSP_SHUTDOWN == true) || defined(__DOXYGEN__)
+
+/**
+ * @brief   Sequnetially broadcast an identifier via S to specify a specific way to shutdown or restart.
+ *
+ * @param[in] identifier  Identifier to be broadcasted.
+ */
+void aosSsspShutdownBroadcastIdentifier(unsigned int identifier)
+{
+  // only broadcast anything if a identifier greater than 0 was specified
+  if (identifier > 0) {
+    // broadcast identifier
+    for (unsigned int pulse = 0; pulse < identifier; ++pulse) {
+      // wait one delay time with S being deactivated
+      aosThdUSleep(AOS_SSSP_DELAY);
+
+      // activate S for one AOS_SSSP_DELAY.
+      apalControlGpioSet(&moduleSsspGpioS, APAL_GPIO_ON);
+      aosThdUSleep(AOS_SSSP_DELAY);
+      apalControlGpioSet(&moduleSsspGpioS, APAL_GPIO_OFF);
+    }
+  }
+
+  // let a timeout pass and return
+  aosThdUSleep(AOS_SSSP_TIMEOUT);
+
+  return;
+}
+
+/**
+ * @brief   Wait for a pulse during the SSSP shutdown disambiguation procedure.
+ * @details Whenever a pulse is received, the identifier is incremented.
+ *          Otherwise the internal timer is configured and will eventually trigger a timeout event.
+ *
+ * @param[in]     gpiolistener  Event listener for GPIO events.
+ * @param[in]     sflags        Event flags to be set by edges on the S signal.
+ * @param[in]     timermask     Event maks to use for the internal timer.
+ * @param[in,out] identifier    Identifier variable to increment.
+ *
+ * @return  The event mask of whatever event was received during this function call.
+ */
+eventmask_t aosSsspShutdownWaitForIdentifierPulse(event_listener_t* gpiolistener, const eventflags_t sflags, eventmask_t timermask, unsigned int* identifier)
+{
+  aosDbgCheck(gpiolistener != NULL);
+  aosDbgCheck(sflags != 0);
+  aosDbgCheck(timermask != 0);
+  aosDbgCheck(identifier != NULL);
+
+  // local variables
+  eventmask_t mask;
+  eventflags_t flags;
+  apalControlGpioState_t sstate;
+
+  // arm the timer once
+  if (!chVTIsArmed(&_delayTimer)) {
+    chEvtRegisterMask(&_eventSourceDelay, &_eventListenerDelay, timermask);
+    chVTSet(&_delayTimer, chTimeUS2I(AOS_SSSP_TIMEOUT), _timerCallback, &_eventSourceDelay);
+  }
+
+  // wait for any event to occur (do not apply any filters in order not to miss any events)
+  mask = chEvtWaitOne(ALL_EVENTS);
+
+  // GPIO event
+  if (mask & gpiolistener->events) {
+    // retreive flags without clearing them
+    flags = gpiolistener->flags;
+    apalControlGpioGet(&moduleSsspGpioS, &sstate);
+    if (flags == sflags) {
+      apalControlGpioGet(&moduleSsspGpioS, &sstate);
+      // if this was the end of a pulse
+      if (sstate == APAL_GPIO_OFF) {
+        // restart the timer
+        chVTReset(&_delayTimer);
+        chVTSet(&_delayTimer, chTimeUS2I(AOS_SSSP_TIMEOUT), _timerCallback, &_eventSourceDelay);
+        // increment the identifier
+        ++(*identifier);
+      }
+    }
+  }
+  // timer event
+  else if (mask & _eventListenerDelay.events) {
+    // unregister event
+    chEvtUnregister(&_eventSourceDelay, &_eventListenerDelay);
+  }
+  // any further events must be handled externally
+
+  return mask;
+}
+
+#endif /* (AMIROOS_CFG_SSSP_SHUTDOWN == true) */
+
+#endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
+
+/** @} */
